Add the "welcome" dialog (with button to switch) to the wikitext editor
Closed, ResolvedPublic1 Story Points

Description

We have complaints at enwiki that the Single Edit Tab (SET) feature has gotten existing editors "stuck" in the wikitext editor. The pencil icon is too subtle, and there are no educational messages that point it out or provide any information about what to do when you previously used both editors, but your last editor pre-SET happened to be the wikitext editor.
We've heard similar complaints at mediawiki.org.

The visual editor provides new editors with a welcome box that has a prominent link to switch to the wikitext editor, plus education features that highlight links, Cite, etc. The visual editor offers existing, logged-in editors with both a dialog box to choose preferences and also educational features. But the wikitext editor offers editors nothing: no opportunity to switch upon opening and no information about how to switch if you wanted to do so.

EDIT by Elitre: Please help translate interface messages related to this change. Thanks!
Those are included in this small group:
*https://translatewiki.net/w/i.php?title=Special:Translate&group=ext-visualeditor-ve-wmf&filter=%21translated&action=translate

Here's the specific list - in case you want to create them "manually", by replacing "en" with your language code:

https://translatewiki.net/wiki/MediaWiki:Visualeditor-welcomedialog-switch-ve/en
https://translatewiki.net/wiki/MediaWiki:visualeditor-welcomedialog-action/en
https://translatewiki.net/wiki/MediaWiki:visualeditor-welcomedialog-content/en
https://translatewiki.net/wiki/MediaWiki:visualeditor-welcomedialog-content-thanks/en
https://translatewiki.net/wiki/MediaWiki:visualeditor-welcomedialog-switch/en
https://translatewiki.net/wiki/MediaWiki:visualeditor-welcomedialog-title/en

If there's nothing to translate or you simply feel like walking an extra mile, please consider publishing a heads-up about this change on your wiki.
Find the instructions here.
Thanks!

Related Objects

Restricted Application added a project: VisualEditor. · View Herald TranscriptApr 27 2016, 7:03 PM
Restricted Application added a subscriber: Aklapper. · View Herald Transcript
Elitre added a subscriber: Elitre.Apr 28 2016, 8:46 AM
Jdforrester-WMF renamed this task from Add "this is how to switch" education message to the wikitext editor to Add the "welcome" dialog (with button to switch) to the wikitext editor.Apr 28 2016, 5:36 PM
Jdforrester-WMF triaged this task as High priority.
Jdforrester-WMF added a project: WikiEditor.
Jdforrester-WMF set the point value for this task to 1.

I don't think the part about the preferences dialog is accurate.

I've started moving code around for this, but am going to need more information from James when he is available.

I don't think the part about the preferences dialog is accurate.

How so?
Don't people get the pop-up about choosing the editing system they prefer (which will save that setting in their Preferences)?

Change 286106 had a related patch set uploaded (by Alex Monk):
Add WTE welcome dialog

https://gerrit.wikimedia.org/r/286106

You're correct that the visual editor offers it, VE also sets it up to show on the wikitext editor.

Jdforrester-WMF closed this task as Resolved.May 10 2016, 11:29 PM

Change 286106 merged by jenkins-bot:
Add WTE welcome dialog

https://gerrit.wikimedia.org/r/286106

Change 288437 had a related patch set uploaded (by Jforrester):
Add WTE welcome dialog

https://gerrit.wikimedia.org/r/288437

For clarity, when we deploy this, who will see the dialog?
I'm assuming newly registered editors and logged out editors only.
I don't expect to see it (at least not on wikis I edited before).

For clarity, when we deploy this, who will see the dialog?
I'm assuming newly registered editors and logged out editors only.
I don't expect to see it (at least not on wikis I edited before).

  • All logged-in users who've never seen either version (if you see the WT version you won't see the VE one, and vice versa).
  • All logged-out users who've never seen either version, or who haven't edited in > 30 days, or who cleared their cookies.
Elitre added a comment.EditedMay 12 2016, 6:56 PM

Ok, I just learned it's an all or nothing thing - it's unfeasible to do otherwise except for what James says above.

Also, it looks like this can't reach SET wikis only, so all the others will get a bit of unnecessary noise.
Hence, despite the mention in Tech News, I'm also going to send a heads-up to some Village Pumps (it's a one-time dialog, and VEditors who have seen it in VE won't get it, but still).

Elitre updated the task description. (Show Details)May 12 2016, 7:53 PM

I need additional information to communicate with some communities properly about this dialog, since it’s on its way to non-SET wikis as well (which includes wikis where choosing to edit with the visual editor isn’t a problem ATM).

It seems to me that it doesn’t make much sense to show such a dialog to

  1. people who have been editing for months or years now (well, beyond the annoyance, I hope it will convey somehow, at least to some of them, our sentiments of excitement and gratefulness for having them around.);
  2. people who chose to hide the visual editor, simply because they already know where to go/what to do to find it.

Q: Can the conditions applied to IPs "(who haven't edited in > 30 days, or who cleared their cookies") be applied to the group of users listed above?

Q: Will logged-in editors get this dialog only once, or once per browser/device/until they clean cookies/reset prefs?

Additionally, at least on wikis where VE isn’t the “default/primary” editor yet, it seems to me that to achieve a good result this new dialog needs to work in combination with the “click on this toolbar button to switch” one. (I'm aware that this dialog isn't the beginning of a "guided tour"-kind of thing.)

Q: How will this dialog work at wikis where the visual editor is not the first editor for everyone (maybe still a Beta Feature even), especially for users who haven’t opted in yet, so they only have one edit tab?

The way I see it, the user sees the dialog - the user stays in WT or switches to VE - the user should automatically get the pop-up which informs him/her about the “toolbar switch” option, but this doesn't happen consistently currently.

At a SET, VE-primary wiki (like pl.wp), choosing WT after the welcome message will show the "switch" popup, not so when you choose VE, which is the point T128781 tried to make. (Unhelpfully, the user can also close the “toolbar switch popup” by mistake, per T128573).

So it seems to me that the part where this task asks for "information about how to switch if you wanted to do so" is not solved by the welcome dialog. Offering just the choice to get in but not that of learning how to move back and forth seems weird.

Q: Is the situation in the pl.wp example going to be the same at WT-primary wikis?

A few final thoughts:

  1. If the switch pop-up doesn't always and immediately follow the welcome dialog, I think we'd fail in educating effectively about the switching mechanism (which has been in place for 6 months and we still hear today of people who haven't discovered it), which will still be for several editors at lots of wikis their only chance to get VE for a while (and whose discovery is overall useful as it will make things easier whenever SET lands there).
  1. If there is even just one chance that the editor wants to enable the VE permanently, on non-SET wikis for example, there's no indication of how to do so (we can try to fix this by placing this information on documentation pages and hoping for the best). Offering a one-time choice to enter the visual editor without a clear indication of how to return there or activate it permanently looks a bit meh, regardless of the fact that our intentions are not incentivizing adoption here, clearly.

Thanks for the attention.

No, the "haven't edited in > 30 days" is just another way of saying they don't have a cookie.

Logged-in users will get it only once per wiki, unless they reset their preferences.

There's no difference between SET and non-SET wikis, or non-default wikis; they will be welcomed to editing either way.

The "switch" pop-up is an SET-only thing and won't be shown.

Elitre added a comment.EditedMay 14 2016, 7:29 AM

The text below echoes the bulk of a message which I'll post on some wikis ASAP.
(If you're an editor of a wiki with the Single Edit Tab system instead, please see the guide if you're not sure you know or remember how things will work for you, as some of the content below doesn't apply to you.)

*I want to make sure that, although users will see this dialog only once, they can read it in their language as much as possible. Please see the description of the task if you can help with that.

*I also want to underline that the dialog does not change in any way current site-wide and personal configurations of the visual editor. Nothing changes permanently for users who chose to hide the visual editor in their Preferences, or for wikis where it's still a Beta Feature, or for wikis where certain groups of users don't get the visual editor tab.
**There is a slight chance that you get a few more questions than usual about the visual editor. Please refer people to local or centralized documentation, or to the feedback page, and feel free to ping me directly if you have questions too.

*Finally, I want to acknowledge that, while not everyone will see that dialog, many of you will; if you're reading this you are likely not the intended recipients of that dialog, so you may be confused or annoyed by it - and if this is the case, I'm truly sorry about that. Please feel free to cross-post this message at other venues on your wiki if you think it will help avoid that users feel caught by surprise by this change.

Elitre updated the task description. (Show Details)May 14 2016, 7:34 AM
jayvdb added a subscriber: jayvdb.May 14 2016, 7:54 AM
Elitre added a comment.EditedMay 14 2016, 8:23 AM

Your help is appreciated in spreading the word at your community, as I don't plan sending a MassMessage.
Here are some instructions for your convenience.
I posted a heads-up at several Wikisources and Wiktionaries, as the visual editor became a Beta Feature there only recently and users may not be aware of how the single edit tab system they have there works.

Elitre updated the task description. (Show Details)May 14 2016, 9:36 AM
Elitre updated the task description. (Show Details)May 15 2016, 2:00 PM
Elitre updated the task description. (Show Details)May 16 2016, 8:18 AM

Change 288437 abandoned by Jforrester:
Add WTE welcome dialog

Reason:
Decided against.

https://gerrit.wikimedia.org/r/288437

For clarity, the button to switch isn't shown in namespaces where the visual editor is not available.

sladen added a subscriber: sladen.EditedMay 21 2016, 10:24 AM

Before tracking this down, I had filed two issues:

  • T135897: should have an obvious action-free close mechanism (eg. "[X]")
  • T135898: should be a11y compliant for keyboard users.

I would strongly encourage reverting these changes until those issues can be addressed.

Why does this actually appear also on sites without VE?

Why does this actually appear also on sites without VE?

sites without VE = loginwiki and votewiki?

NickK added a subscriber: NickK.May 21 2016, 7:37 PM

I am currently making similar edits to multiple projects (I have editing all of them before), and I am very annoyed by this message. I have to close this message in each and every project, and I do not have a button to close it - I have to move my mouse to "Start editing" and click it on every wiki.

I would like to have any of these solutions:

  • opt out of this message,
  • change settings so that each user sees it just once
  • add an intuitive close button (e.g. "Esc").

Is any of these solutions available (preferrably the first one, of course)? It is very annoying in the current state.

Congrats. Now you don't even have to use VisualEditor in order to be persecuted by it.

sladen added a comment.EditedMay 24 2016, 10:10 AM

This bug report started out with the premise "We have complaints at enwiki that the Single Edit Tab (SET) feature".

It's unclear what the nature of the complaints were; but an issue with design/implementation of the "Single Edit Tab (SET)" seems to have been identified; thus it seems likely that this is where the design/UI focus work should go into.

Modal pop-ups that provide inconsistent workflow are not generally helpful to users. A modal dialogue with a question is requesting a user to make a decision they are not likely to be informed about. A new user does not have the vocabulary or the context to make such a decision. The user has already clicked Edit, and so it is up to us to undertake the action the user requested without pestering/interrupting them further.

There are likely to be better design solutions available than a modal-dialogue. We do not want users to be reminded of paywall pop-up advertising, and we do not want users to have to make a choice when they don't need to.

Instead I would encourage re-investigation of the design of the Single Edit Tab (SET) concept, as that seems to have been the initiator of this story.

For any alternative design solutions proposed, these should ideally receive a11y testing. This probably means a baseline of something like:

  1. Red/Blue colour-blind
  2. Touchscreen only (on-screen keyboard)
  3. Keyboard only (no mouse/pointer)
  4. Screen-reader/Braille simulation (screen turned off)

With such a mechanism in place the a11y testing would have caught some of the implementation issues earlier, and probably also the more general modal-dialogue design issues.

("a11y" = "accessibility")

NickK awarded a token.May 30 2016, 4:59 PM
Poyekhali added a subscriber: Poyekhali.